﻿// --------------------------------------------------------------------------------------------------------------------
// <copyright file="UpdateForm.cs" company="Logica">
//   GPL
// </copyright>
// <summary>
//   Defines the UpdateForm type.
// </summary>
// --------------------------------------------------------------------------------------------------------------------
namespace AopForms.Aspect
{
    using System;
    using System.Windows.Forms;
    using PostSharp.Laos;

    [Serializable()]
    internal class UpdateForm : OnMethodBoundaryAspect
    {
        public override void OnEntry(MethodExecutionEventArgs eventArgs)
        {
            if (eventArgs.Instance == null)
                throw new InvalidOperationException("Cannot decorate UpdateForm on static classes");

            if (!(eventArgs.Instance is Form))
                throw new InvalidOperationException("UpdateForm requires a Form to operate");

            object sender = eventArgs.GetReadOnlyArgumentArray()[0];
            ElementEventArgs ea = (ElementEventArgs)eventArgs.GetReadOnlyArgumentArray()[1];

            Form frm = (Form)eventArgs.Instance;
            frm.Text = ea.Element + " -said by " + sender;
        }
    }
}
