﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using PostSharp.Laos;

namespace AopForms
{
    /// <summary>
    /// Controller for dispatching events
    /// </summary>
    class Controller
    {
        /// <summary>
        /// event that something has happened
        /// </summary>
        public static event EventHandler<ElementEventArgs> SomethingCreated;

        /// <summary>
        /// invoke the SomethingCreated event
        /// </summary>
        /// <param name="source">aspect which invokes this event</param>
        /// <param name="ea"></param>
        internal static void InvokeSomethingCreated(LaosAspect sender , ElementEventArgs ea)
        {
            if (SomethingCreated == null) return;

            SomethingCreated.Invoke(sender, ea);
        }
    }
}
