﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using PostSharp.Laos;
using System.Text.RegularExpressions;
using System.Diagnostics;
using Logica.Kbn.PostSharpAspect.Exception;

namespace Logica.Kbn.PostSharpAspect
{
    [Serializable]
    public class RegexValidationAspect : OnMethodBoundaryAspect
    {
        public RegexValidationAspect(string regEx)
        {
            this.RegularExpression = regEx;
        }

        public string RegularExpression { get; private set; }
        public bool MustMatch { get; set; }

        /// <summary>
        /// validate before the property setter occurs
        /// </summary>
        /// <param name="eventArgs"></param>
       [DebuggerStepThrough()]
        public override void OnEntry(MethodExecutionEventArgs eventArgs)
        {
            if (eventArgs.GetReadOnlyArgumentArray() != null)
            {
                string value = (string)eventArgs.GetReadOnlyArgumentArray()[0];

                if (Regex.IsMatch(value, RegularExpression) != this.MustMatch)
                    throw new ValidationException("Value did not match the specified regular expression [" + RegularExpression + "]", eventArgs);
            }

            base.OnEntry(eventArgs);
        }
    }
}
